> For the complete documentation index, see [llms.txt](https://docs.relevant-digital.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.relevant-digital.com/technical/integration/javascript-api/relevantdigital.definevideoslots.md).

# relevantDigital.defineVideoSlots()

Define video slots before calling [relevantDigital.loadPrebid()](/technical/integration/javascript-api/relevantdigital.loadprebid.md). Then use [relevantDigital.loadVideoUrls()](/technical/integration/javascript-api/relevantdigital.loadvideourls.md) to retrieve VAST URLs for your player.

For a complete instream implementation, see [Instream video with HBM and GAM](/technical/integration/formats-and-channels/instream-video-with-hbm-and-gam.md).

{% hint style="info" %}
This API currently supports Google Ad Manager only.
{% endhint %}

### Parameters

Pass an array of video slot settings.

#### `path`

Required. The Google Ad Manager ad unit path, such as `"/12345/articles/pre_roll"`.

#### `id`

Optional. A unique slot ID for [relevantDigital.loadVideoUrls()](/technical/integration/javascript-api/relevantdigital.loadvideourls.md). An ID is generated when omitted.

#### `custParams`

Optional. Custom ad-server targeting parameters.

### Return value

Returns a `VideoSlot` object for each input setting. Use `videoSlot.getSlotElementId()` to retrieve a slot ID.

### Example

```
window.relevantDigital = window.relevantDigital || {};
relevantDigital.cmd = relevantDigital.cmd || [];
relevantDigital.cmd.push(() => {
    const videoSlots = relevantDigital.defineVideoSlots([
        {
           path: '/12345/articles/pre_roll',
           id: 'preroll_1',
           custParams: { 'section': 'articles' },
        },
        {
           path: '/12345/articles/pre_roll',
           id: 'preroll_2',
           custParams: { 'section': 'articles' },
           },
    ]);
    

    // Call relevantDigital.loadPrebid() "as normal"
    relevantDigital.loadPrebid({ ... });
    
    // Get the URLs with VAST XML that should be used with the video player
    relevantDigital.loadVideoUrls(['preroll_1', 'preroll_2'], (vastUrls) => {
       console.info('VAST URLs:', vastUrls);
       // TODO: Invoke video player here
    });
});
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.relevant-digital.com/technical/integration/javascript-api/relevantdigital.definevideoslots.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
